﻿using System;
using System.Collections.Generic;
using System.Drawing;

namespace TestProject
{
    /// <summary>
    /// 8각형
    /// </summary>
    public class Octagon
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 난수기
        /// </summary>
        private static Random _random = new Random();

        /// <summary>
        /// 색상 배열
        /// </summary>
        private static Color[] _colorArray =
        {
            Color.Aquamarine,
            Color.Red,
            Color.Orange,
            Color.Yellow,
            Color.SeaShell,
            Color.RosyBrown,
            Color.Cyan,
            Color.Blue,
            Color.LightBlue,
            Color.Fuchsia,
            Color.Beige,
            Color.BlueViolet,
            Color.Orange
        };

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 포인트 배열
        /// </summary>
        public PointF[] PointArray = null;

        /// <summary>
        /// 채우기 색상
        /// </summary>
        public Color FillColor = Color.Black;

        /// <summary>
        /// 자식 리스트
        /// </summary>
        public List<Octagon> ChildList = new List<Octagon>();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Octagon(pointArray)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="pointArray">포인트 배열</param>
        public Octagon(PointF[] pointArray)
        {
            PointArray = pointArray;

            FillColor = _colorArray[_random.Next(0, _colorArray.Length)];

            FillColor = Color.FromArgb(80, FillColor);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 그리기 - Draw(graphics)

        /// <summary>
        /// 그리기
        /// </summary>
        /// <param name="graphics">그래픽스</param>
        public void Draw(Graphics graphics)
        {
            using(Brush brush = new SolidBrush(FillColor))
            {
                graphics.FillPolygon(brush, PointArray);
            }

            graphics.DrawPolygon(Pens.Black, PointArray);

            foreach(Octagon child in ChildList)
            {
                child.Draw(graphics);
            }
        }

        #endregion
    }
}